//
// Copyright (C) 2013-2016  Taiyou Sakashita, Hiroko Yamada
//
// Make Time Series 2015/08/10
// Modified for changing Input Time UTC(old version) -> Local Time(new version)  2016/07/01
// 

import java.io.*;
import java.util.*;
import java.text.DecimalFormat;
import java.util.Date;
import java.util.Calendar;

public class time_series
{

// Length of the Data in Column/Line Direction
static int X;
static int Y;

// Year/Month/Day/Minite
static int YYYY;
static int MM;
static int DD;
static int HH;

static int MN;

// Time of Picked Data
static int Pick_Time[] = new int[6+1];

// Picked Pixel
static int Pick_Pix[] = new int[2+1];

// Time of Picked Data
static int Pick_Time_UTC[] = new int[6+1];
static int Pick_Time_Local[] = new int[6+1];

// Extracted parameter
static float Extract_param[] = new float[3+1];


// Standard Latitude/Longitude Data
static float STN_LAT[][];
static float STN_LNG[][];

// Calculation Start Hour
static int Start_HH;

// Calculation End Hour
static int End_HH;

// File Type
static String ftype;

// Time File Type
static String ttype;


// Directory Name to Read Original Data
static String input_DIR;

// Directory Name to Write Time Series Data
static String TimeS_DIR;

// Directory Name to Read Standart Latitude/Longitude Data
static String SL_DIR;

// Number of Used Files
static int nFile = 0;

// Filename of Standard Latitude
static String LATname;

// Filename of Standard Longitude
static String LNGname;

// Solar Zenith Angle
static double SZA;

// TIME DIFF  & Time Type
static double TIME_DIFF;
static String TIME_Code;
//jd_UTC_PickUP
static double jd_UTC_PickUP;

// Use for Calculate SZA
static double a1 = 0.000075;
static double a2 = 0.001868;
static double a3 = 0.032077;
static double a4 = 0.014615;
static double a5 = 0.040849;

static double b1 = 0.006918;
static double b2 = 0.399912;
static double b3 = 0.070257;
static double b4 = 0.006758;
static double b5 = 0.000907;
static double b6 = 0.002697;
static double b7 = 0.001480;

static  String wfilename;
static PrintWriter pw;

public static void main(String args[])
{

  DecimalFormat df = new DecimalFormat();
  df.applyLocalizedPattern( "00" );


  int I;

  double LAT;
  double LNG;



  YYYY = Integer.valueOf(args[0]).intValue();
  MM   = Integer.valueOf(args[1]).intValue();
  DD   = Integer.valueOf(args[2]).intValue();

  HH   = 0;
  MN   = 0;

  LAT = Double.valueOf(args[3]).doubleValue();
  LNG = Double.valueOf(args[4]).doubleValue();

  //output/YYYYMM Dir confirm and create
  File newfile = new File("output/" + YYYY + df.format(MM));
  if (newfile.exists()) {
    System.out.println( newfile + " already exists");
  }else if (newfile.mkdir()){
    System.out.println("Succeeded to create a directory");
  }else{
    System.out.println("Failed to create a directory");
  }

  date_errorcheck();
  initialization();

  wfilename = TimeS_DIR + YYYY + df.format(MM) + "/" + YYYY + df.format(MM) + df.format(DD)+"." + TIME_Code  + ftype + ".ts.txt";
  try{
     pw = new PrintWriter(new BufferedWriter(new FileWriter(wfilename)));
  }catch(IOException e){

      System.err.println(wfilename + " write error\n");  
      System.exit(1);
  }


  System.out.print(wfilename +"  Writing ...");

  extract(LAT, LNG);

  pw.println(); 
  pw.close(); 


  return;


}//main


public static void extract(double LAT, double LNG)
{

  DecimalFormat df = new DecimalFormat();
  df.applyLocalizedPattern( "00" );
  DecimalFormat ddate = new DecimalFormat();
  ddate.applyLocalizedPattern( "000000" );


 // Date Data Extracted(UTC)
  int UYYYY;
  int UMM;
  int UDD;
  int UHH;

  int UMN;

  int I,J;
  
  // Complement Flag
  int Complement_Flag;

  File file;


  // Data Read
  float DR[][] = new float[Y+1][X+1];

  // Filename of Original Data
  String filename;

  // Time of Data -- UTC
  float TimeD;

  // Time of Data -- local
  float TimeD_UTC;
  
  // Answer
  float ANS;
  
  // UTC Time
  int UTime[] = new int[5+1];
  double jd_UTC = 0;
  jday jday_jul = new jday();
  double jd_jul_ymdhn=(double)jday_jul.TransDateToJD(YYYY,MM,DD,HH,MN,0); //1.Local Time to JD(Local)
  jd_UTC= jd_jul_ymdhn - TIME_DIFF/24.0;	//  2.JD(Local)  to JD(UTC)

  UTime = jday_jul.jd2ymdhn(jd_UTC);//  3.JD(UTC) to Calendar(UTC)
 
     UYYYY = UTime[1];
     UMM = UTime[2];
     UDD = UTime[3];
     UHH = UTime[4];
     UMN = UTime[5];
   
  Pick_Pix = search_extract_pixel(LAT, LNG);//searh nearest pixel
  bin bb = new bin();
  Complement_Flag = 0;

  int ifile=0;
  String strDate =  df.format(UDD) + df.format(UHH) + df.format(UMN);
  int iDate = Integer.valueOf(strDate).intValue();

  for(ifile=iDate;ifile<=iDate+10000;ifile++) { // iDate : DDHHMN  ex: 011530 - 021530
 
 filename = input_DIR + UYYYY + df.format(UMM) + "/" + UYYYY + df.format(UMM) + ddate.format(ifile) + ftype ;
 		file = new File(filename);
   
		if(file.exists()){
 			UYYYY = UYYYY;
			UMM = UMM;
			UDD = (int)(ifile/10000);
			UHH = (int)((ifile - UDD*10000)/100);
			UMN = (int)((ifile - UDD*10000 - UHH*100));
			
			time_check(UYYYY, UMM, UDD, UHH, UMN, LAT, LNG);
  
  			if(SZA < 90){
    			DR = bb.bin2f(filename, X, Y);
     			ANS = (float)DR[Pick_Pix[2]][Pick_Pix[1]];
 
			}else{
  				ANS = 0;
    		}//fi
  
 			// Extract
  			Extract_param[1] = (float)LAT;
  			Extract_param[2] = (float)LNG;
  			Extract_param[3] = ANS; 

			write_txt(); 

		}//if exist
}
  return;


}//extract



public static int[] search_extract_pixel(double LAT, double LNG)
{

  int I,J;

  // Minimum Distance
  double MIN_DIS = 10000;

  // Distance of Column/Line Direction
  double DIS_X;
  double DIS_Y;

  // Pixel Number of Minimum Distance of Column/Line Direction
  int MIN_X = 1;
  int MIN_Y = 1;

  // Pixel of the Answer in the X/Y Direction
  int ANS_Pixel[] = new int[2+1];

  double DIS_Border;
  
  if(X<Y)
  {
    DIS_Border = (STN_LNG[1][2]-STN_LNG[1][1])*1.5;
    
  }else{
  
    DIS_Border = (STN_LAT[1][1]-STN_LAT[2][1])*1.5;
  }

  for(I=1;I<=Y;I++)
  {
     for(J=1;J<=X;J++)
     {
        DIS_X = Math.pow(LNG - STN_LNG[I][J], 2);
        DIS_Y = Math.pow(LAT - STN_LAT[I][J], 2);


        if( Math.sqrt(DIS_X + DIS_Y) < MIN_DIS) 
        {
           MIN_DIS = Math.sqrt(DIS_X + DIS_Y);
           MIN_X = J;
           MIN_Y = I;

        }//fi

     }//J
  }//I

  if(MIN_DIS > DIS_Border)
  {
     System.out.println(LAT + ", " + LNG + " is out of range");
     System.exit(1);

  }//fi

  System.out.println("Pick up " + LAT + ", " + LNG);

  ANS_Pixel[1] = MIN_X;
  ANS_Pixel[2] = MIN_Y;


  return ANS_Pixel;


}//search_extract_pixel


public static void time_check(int Year, int Month, int Day, int Hour, int Minute, double LAT, double LNG)
{

  DecimalFormat df = new DecimalFormat();
  df.applyLocalizedPattern( "00" );

   jday jday_jul_local = new jday();
 
  // Local Time
  int LTime[] = new int[5+1];

  // Local Year/Month/Day/Hour/Minute/Second
  float Time[][] = new float[Y+1][X+1];

  // Filename of Time Data
  String Timename;

  Timename = input_DIR + Year + df.format(Month) + "/" + Year + df.format(Month) + df.format(Day) + df.format(Hour) + df.format(Minute) + ttype;

  bin bb = new bin();

  Time = bb.bin2f(Timename, X, Y);

  jd_UTC_PickUP=(double)jday_jul_local.TransDateToJD(Year,Month,Day,0,0,0);// 1.Local Time to JD(Local)
  jd_UTC_PickUP = jd_UTC_PickUP +(double)Time[Pick_Pix[2]][Pick_Pix[1]]; // 2. add JD(Local) and Pixel Time(hour,min,sec) 
  Pick_Time_UTC = jday_jul_local.jd2ymdhn(jd_UTC_PickUP); // 3.JD(Pick Time UTC) to Calendar(UTC) 
  double jd_utctolocal = jd_UTC_PickUP + TIME_DIFF/24.0; // 4.JD(Pick Time UTC) to JD(Local)
  Pick_Time_Local = jday_jul_local.jd2ymdhn(jd_utctolocal); // 5.JD(Local) to  Calendar(Local) 
  
  // Calculate Solar Zenith Angle
  SZA = cal_sza(Pick_Time_UTC[1], Pick_Time_UTC[2], Pick_Time_UTC[3], Pick_Time_UTC[4], Pick_Time_UTC[5], (double)LAT, (double)LNG);

  if(SZA >= 90)
  {
    System.out.println("Solar Zenith Angle = " + SZA + " is more than 90 Degrees");
    //System.exit(1);    
  }//fi
  
  return;

}//time_check


public static int[] shift_time(int Year, int Month, int Day, int Hour, int Minute, double Shift_HH) 
{

  // Shifted Year/Month/Day/Hour/Minute
  int Shift_Time[] = new int[5+1];

  Calendar time = Calendar.getInstance();

  time.set(Calendar.YEAR, Year);
  time.set(Calendar.MONTH, Month-1);
  time.set(Calendar.DAY_OF_MONTH, Day);
  time.set(Calendar.HOUR_OF_DAY, Hour);
  time.set(Calendar.MINUTE, Minute);

  // Shift Time
  time.add(Calendar.MINUTE, (int)Math.floor(Shift_HH*60));
  

  Shift_Time[1] = time.get(Calendar.YEAR);
  Shift_Time[2] = time.get(Calendar.MONTH) + 1;
  Shift_Time[3] = time.get(Calendar.DAY_OF_MONTH);
  Shift_Time[4] = time.get(Calendar.HOUR_OF_DAY);
  Shift_Time[5] = time.get(Calendar.MINUTE);


  return Shift_Time;


}//shift_time


public static int get_lastday(int Year, int Month)
{

  // Last Day of the Month
  int Last_DD;

  Calendar time = Calendar.getInstance();

  time.set(Calendar.YEAR, Year);
  time.set(Calendar.MONTH, Month-1);
  time.set(Calendar.DAY_OF_MONTH, 1);
  time.set(Calendar.HOUR_OF_DAY, 0);
  time.set(Calendar.MINUTE, 0);

  Last_DD = time.getActualMaximum(Calendar.DAY_OF_MONTH);


  return Last_DD;


}//get_lastday


public static int date2doy(int Year, int Month, int Day, int Hour, int Minute)
{

  DecimalFormat df = new DecimalFormat();
  df.applyLocalizedPattern( "00" );

  // Day of Year
  int DOY;

  Calendar time = Calendar.getInstance();

  time.set(Calendar.YEAR, Year);
  time.set(Calendar.MONTH, Month-1);
  time.set(Calendar.DAY_OF_MONTH, Day);
  time.set(Calendar.HOUR_OF_DAY, Hour);
  time.set(Calendar.MINUTE, Minute);


  DOY = time.get(Calendar.DAY_OF_YEAR);


  return DOY;


}//date2doy


public static double cal_sza(int Year, int Month, int Day, int Hour, int Minute, double LAT, double LNG)
{

  // Day of Year
  int DOY;
  
  // Local Time
  int Local_Time[] = new int[5+1];
  
  // Greenwith Meridian Time
  double UTC_Time;
  
  // Solar Declination
  double DEC;
  
  double A;
  double B;
  
  // Hour Angle
  double t;
  
  // Equation of Time
  double ET;
  
  // Mean Solar Time
  double MST;
  
  // True Solar Time
  double TST;
  
  // cos(Solar Zenith Angle)
  double SZA_cos;
  
  // Solar Zenith Angle
  double ANS;
  

  // Calculate HH + MN
  UTC_Time = Hour + (double)Minute / 60;
  
   // Calculate Local Time
  Local_Time = shift_time(Year, Month, Day, Hour, Minute, TIME_DIFF);

  // Calculate Day of Year
  DOY = date2doy(Local_Time[1], Local_Time[2], Local_Time[3], Local_Time[4], Local_Time[5]);
  
  LAT = Math.toRadians(LAT);
  

  A = (2*Math.PI*(DOY-1)) / 365;
  DEC = b1 - b2 * Math.cos(A) + b3 * Math.sin(A) - b4 * Math.cos(2*A) + b5 * Math.sin(2*A) - b6 * Math.cos(3*A) + b7 * Math.sin(3*A);
  
  //System.out.println("Solar Declination = " + Math.toDegrees(DEC));
  
  B = (2*Math.PI*(DOY-1)) / 365;
  ET = ((a1 + a2*Math.cos(B) - a3*Math.sin(B) - a4*Math.cos(2*B) - a5*Math.sin(2*B))*12) / Math.PI;
  MST = UTC_Time + LNG / 15;
  TST = MST + ET;
  t = (15 * Math.PI/180)*(TST-12);
  
  
  SZA_cos = Math.cos(Math.PI/2 - DEC)*Math.cos(Math.PI/2 - LAT) + Math.sin(Math.PI/2 - DEC)*Math.sin(Math.PI/2 - LAT)*Math.cos(t);
  ANS = Math.toDegrees(Math.acos(SZA_cos));
  
  
  return ANS;
  
  
}//cal_sza

public static void date_errorcheck()
{

  DecimalFormat df = new DecimalFormat();
  df.applyLocalizedPattern( "00" );


  // Last Day of the Month
  int Last_DD;


  // Year Check
  if(YYYY <= 0)
  {
     System.out.println("Year " + YYYY + " is less than or equal to 0");
     System.exit(1);

  }//fi

  // Month Check
  if(MM <= 0 || MM > 12)
  {
     System.out.println("Month " + MM + " does not exist");
     System.exit(1);

  }//fi

  // Day Check
  Last_DD = get_lastday(YYYY, MM);

  if(DD > Last_DD || DD <= 0)
  {
     System.out.println("Date of " + YYYY + df.format(MM) + df.format(DD) + " does not exist");
     System.exit(1);

  }//fi
  

  return;


}//date_errorcheck


public static void initialization()
{

  read_formatfile();


  STN_LAT = new float[Y+1][X+1];
  STN_LNG = new float[Y+1][X+1];

  read_standard_latlng();

  return;

}//initialization


static public void read_formatfile()
{

  // Present Line
  int pline=1;

  String filename;
  String readline;
  String param[] = new String [100+1]; 


  filename = "config/format.txt";


  // Read Format File
  try
  {
       
    System.out.print(filename +"  Loading ...");

    BufferedReader br = new BufferedReader(new FileReader(filename));

    while( (readline = br.readLine()) != null ){

        StringTokenizer st = new StringTokenizer(readline);

	 param[pline] =  st.nextToken(", ");

        pline++;
                 
    }//while

    br.close();
	
  }catch (IOException e){

      System.err.println("Initialize error\n");
      System.exit(1);

   }

   System.out.println(" finish");

  
  TIME_DIFF = Double.valueOf(param[1]).doubleValue();
  TIME_Code = param[2];
  X = Integer.valueOf(param[3]).intValue();
  Y = Integer.valueOf(param[4]).intValue();

  ftype = param[5];
  ttype = param[10];

  input_DIR = param[6];
  TimeS_DIR = param[7];
  SL_DIR = "config/";

  LATname = param[8];
  LNGname = param[9];

  Start_HH = 0;
  End_HH = 23;

  return;

}//read_formatfile


public static void read_standard_latlng()
{

  // Filename of Latitude/Longitude Data
  String lat_filename;
  String lng_filename;

  lat_filename = SL_DIR + LATname;
  lng_filename = SL_DIR + LNGname;


  bin bb = new bin();

  STN_LAT = bb.bin2f(lat_filename, X, Y);
  STN_LNG = bb.bin2f(lng_filename, X, Y);


  return;


}//read_standard_latlng


static public void write_txt() 
{

	 pw.write(Extract_param[1] + " " + Extract_param[2] + " " + STN_LAT[Pick_Pix[2]][Pick_Pix[1]] + " " + STN_LNG[Pick_Pix[2]][Pick_Pix[1]] + " " + Extract_param[3] + " " + Pick_Time_Local[1] + " " + Pick_Time_Local[2] + " " + Pick_Time_Local[3] + " " + Pick_Time_Local[4] + " " + Pick_Time_Local[5] + " " + Pick_Time_Local[6]  + " " + TIME_Code );
     pw.println();

   return;

}//write_txt


}//EOF
